#include "DXUT.h"
#include <d3dx10.h>
#include <d3d10.h>

#include "FullScreenQuad.h"

#define NUM_TONEMAP_TEXTURES  5
#define NUM_BLOOM_TEXTURES    2

HRESULT MeasureLuminance(ID3D10Device *pd3dDevice);

HRESULT BrightPassFilter(ID3D10Device *pd3dDevice);

HRESULT RenderBloom(ID3D10Device *pd3dDevice);

void    ReleaseHDR(void);

HRESULT InitHDR(ID3D10Device *pd3dDevice, unsigned int w, unsigned int h);

HRESULT GetSampleOffsetsForBloom(float TexSize, float afTexCoordOffset[15], D3DXVECTOR4* avColorWeight, float fDeviation, float fMultiplier );

float   GaussianDistribution( float x, float y, float rho );

void    RenderToHDR   (ID3D10Device *pd3dDevice);
void    ShowHDR       (ID3D10Device *pd3dDevice);
void    RestoreFromHDR(ID3D10Device *pd3dDevice);

HRESULT CreateDepthBufferTexture( ID3D10Device* pd3dDevice, UINT width, UINT height );

void DeleteDepthBufferTexture(void);

extern bool g_RenderToHDR;
